#ifndef _H_C37D9BAE9F272472CC195306D3A73ED5_MetricData_DCPS_H_
#define _H_C37D9BAE9F272472CC195306D3A73ED5_MetricData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MetricData_.h"


namespace ros_monitoring_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MetricData_TypeSupportInterface;

            typedef MetricData_TypeSupportInterface * MetricData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MetricData_TypeSupportInterface> MetricData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MetricData_TypeSupportInterface> MetricData_TypeSupportInterface_out;


            class MetricData_DataWriter;

            typedef MetricData_DataWriter * MetricData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MetricData_DataWriter> MetricData_DataWriter_var;
            typedef DDS_DCPSInterface_out < MetricData_DataWriter> MetricData_DataWriter_out;


            class MetricData_DataReader;

            typedef MetricData_DataReader * MetricData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MetricData_DataReader> MetricData_DataReader_var;
            typedef DDS_DCPSInterface_out < MetricData_DataReader> MetricData_DataReader_out;


            class MetricData_DataReaderView;

            typedef MetricData_DataReaderView * MetricData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MetricData_DataReaderView> MetricData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MetricData_DataReaderView> MetricData_DataReaderView_out;

            struct MetricData_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MetricData_, struct MetricData_Seq_uniq_> MetricData_Seq;
            typedef DDS_DCPSSequence_var < MetricData_Seq> MetricData_Seq_var;
            typedef DDS_DCPSSequence_out < MetricData_Seq> MetricData_Seq_out;

            class  MetricData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MetricData_TypeSupportInterface_ptr _ptr_type;
                typedef MetricData_TypeSupportInterface_var _var_type;

                static MetricData_TypeSupportInterface_ptr _duplicate (MetricData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MetricData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MetricData_TypeSupportInterface () {};
                ~MetricData_TypeSupportInterface () {};
            private:
                MetricData_TypeSupportInterface (const MetricData_TypeSupportInterface &);
                MetricData_TypeSupportInterface & operator = (const MetricData_TypeSupportInterface &);
            };

            class  MetricData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MetricData_DataWriter_ptr _ptr_type;
                typedef MetricData_DataWriter_var _var_type;

                static MetricData_DataWriter_ptr _duplicate (MetricData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MetricData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MetricData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MetricData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MetricData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MetricData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MetricData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MetricData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MetricData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MetricData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MetricData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MetricData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MetricData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricData_& instance_data) = 0;

            protected:
                MetricData_DataWriter () {};
                ~MetricData_DataWriter () {};
            private:
                MetricData_DataWriter (const MetricData_DataWriter &);
                MetricData_DataWriter & operator = (const MetricData_DataWriter &);
            };

            class  MetricData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MetricData_DataReader_ptr _ptr_type;
                typedef MetricData_DataReader_var _var_type;

                static MetricData_DataReader_ptr _duplicate (MetricData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MetricData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricData_& instance) = 0;

            protected:
                MetricData_DataReader () {};
                ~MetricData_DataReader () {};
            private:
                MetricData_DataReader (const MetricData_DataReader &);
                MetricData_DataReader & operator = (const MetricData_DataReader &);
            };

            class  MetricData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MetricData_DataReaderView_ptr _ptr_type;
                typedef MetricData_DataReaderView_var _var_type;

                static MetricData_DataReaderView_ptr _duplicate (MetricData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MetricData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MetricData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MetricData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MetricData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MetricData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MetricData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MetricData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MetricData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MetricData_& instance) = 0;

            protected:
                MetricData_DataReaderView () {};
                ~MetricData_DataReaderView () {};
            private:
                MetricData_DataReaderView (const MetricData_DataReaderView &);
                MetricData_DataReaderView & operator = (const MetricData_DataReaderView &);
            };
        }

    }

}

#endif
